Subject: [Anima] Bulk transfer in draft-ietf-anima-grasp-distribution-03

From: Brian E Carpenter <[email-masked]>
Date: Tue, 27 Jul 2021 10:28:31 +1200

Recently I rediscovered something that we included in RFC 8990:

"2.8.3. Message Size

GRASP nodes MUST be able to receive unicast messages of at least GRASP_DEF_MAX_SIZE bytes. GRASP nodes MUST NOT send unicast messages longer than GRASP_DEF_MAX_SIZE bytes unless a longer size is explicitly allowed for the objective concerned. For example, GRASP negotiation itself could be used to agree on a longer message size."

In other words, the method of bulk transfer described in draft-ietf-anima-grasp-distribution at Section 4.3 "Bulk Information Transfer" could be improved by first negotiating a larger message size than the default 2048 bytes. That might improve efficiency for distributing large files. (All it really changes in a GRASP implementation over TLS or TCP is the buffer sized set in two or three socket recv() calls.)

Regards
   Brian

---

From: Xun Xiao <[email-masked]>
Date: Mon, 26 Jul 2021 22:39:35 +0000

Hi Brian,

Thanks for the information, I will consider and note it in the '-04' version.

BR/Xun

-----Original Message-----
From: Anima <[email-masked]> On Behalf Of Brian E Carpenter
Sent: Tuesday, 27 July 2021 00:29
To: Anima WG <[email-masked]>
Subject: [Anima] Bulk transfer in draft-ietf-anima-grasp-distribution-03

"2.8.3. Message Size

Regards
   Brian

_______________________________________________
Anima mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/anima

---

From: Michael Richardson <[email-masked]>
Date: Mon, 26 Jul 2021 22:32:04 -0400

Brian E Carpenter <[email-masked]> wrote:
    > In other words, the method of bulk transfer described in
    > draft-ietf-anima-grasp-distribution at Section 4.3 "Bulk Information
    > Transfer" could be improved by first negotiating a larger message size
    > than the default 2048 bytes. That might improve efficiency for
    > distributing large files. (All it really changes in a GRASP
    > implementation over TLS or TCP is the buffer sized set in two or three
    > socket recv() calls.)

Could the receiving end of the transfer simply declare their maximum in the
F_NEG or something like that?

--
Michael Richardson <[email-masked]>   . o O ( IPv6 IøT consulting )
           Sandelman Software Works Inc, Ottawa and Worldwide

---

From: Brian E Carpenter <[email-masked]>
Date: Tue, 27 Jul 2021 14:41:24 +1200

> F_NEG or something like that?

I'm tempted to try implementing something before answering. I have a little toy that I use to move files between machines on my desktop via GRASP, and I think I will play with that when I have some time.

   Brian